%{!?phpname:		%{expand: %%global phpname     php}}
%define _default_patch_fuzz 2


%global contentdir  /var/www
# API/ABI check
%global apiver      20090626
%global zendver     20090626
%global pdover      20080721
# Extension version
%global fileinfover 1.0.5-dev
%global pharver     2.0.1
%global zipver      1.11.0
%global jsonver     1.2.1
%global oci8ver     1.4.9

%global httpd_mmn %(cat %{_includedir}/httpd/.mmn || echo missing-httpd-devel)

%ifarch ppc ppc64
%global oraclever 10.2.0.2
%else
%global oraclever 11.2
%endif

# Regression tests take a long time, you can skip 'em with this
%{!?runselftest: %{expand: %%global runselftest 0}}

# Use the arch-specific mysql_config binary to avoid mismatch with the
# arch detection heuristic used by bindir/mysql_config.
%global mysql_config %{_libdir}/mysql/mysql_config

%global phpversion 5.3.27

# Optional components; pass "--with mssql" etc to rpmbuild.
%global with_oci8 	%{?_with_oci8:1}%{!?_with_oci8:0}
%global with_ibase 	%{?_with_ibase:1}%{!?_with_ibase:0}
%if 0%{?rhel}%{?fedora} > 4
%global with_enchant 1
%else
%global with_enchant 0
%endif
%if 0%{?rhel} >= 5 || 0%{?fedora} >= 12
%ifarch %{ix86} x86_64
%global with_fpm 1
%else
%global with_fpm 0
%endif
%else
%global with_fpm 0
%endif

%if 0%{?__isa:1}
%global isasuffix -%{__isa}
%else
%global isasuffix %nil
%endif

# Flip these to 1 and zip respectively to enable zip support again
%global with_zip 1
%global zipmod zip

Summary: PHP scripting language for creating dynamic web sites
Name: %{phpname}
Version: 5.3.27
Release: 16.2
License: PHP
Group: Development/Languages
URL: http://www.php.net/

Source0: http://www.php.net/distributions/php-%{version}.tar.bz2
Source1: php.conf
Source2: php.ini
Source3: macros.php
Source4: php-fpm.conf
Source5: php-fpm-www.conf
Source6: php-fpm.init
Source7: php-fpm.logrotate

# Build fixes
Patch1: php-5.3.9-gnusrc.patch
Patch2: php-5.3.0-install.patch
Patch3: php-5.2.4-norpath.patch
Patch5: php-5.2.0-includedir.patch
Patch6: php-5.2.4-embed.patch
Patch7: php-5.3.0-recode.patch
# from http://svn.php.net/viewvc?view=revision&revision=311042
# and  http://svn.php.net/viewvc?view=revision&revision=311908
Patch8: php-5.3.17-aconf259.patch
# fix harcoded mysql.sock path
Patch9: php-5.3.9-mysqlnd.patch


# Fixes for extension modules
Patch20: php-4.3.11-shutdown.patch
Patch21: php-5.3.3-macropen.patch

# Functional changes
Patch40: php-5.0.4-dlopen.patch
Patch41: php-5.3.0-easter.patch
Patch42: php-5.3.1-systzdata-v7.patch
# See http://bugs.php.net/53436
Patch43: php-5.3.4-phpize.patch

# Fixes for tests
Patch61: php-5.0.4-tests-wddx.patch
Patch62: php-5.3.3-tests.patch

# RC Patch
Patch91: php-5.3.7-oci8conf.patch

# Missing functions when build with libedit
# See http://bugs.php.net/54450
Patch92: php-5.3.7-readline.patch

# On EL4, include order breaks build against MySQL 5.5
Patch93: php-5.3.9-mysqli.patch

# backport for http://bugs.php.net/50755  (multiple rowset in pdo_dblib)
# http://svn.php.net/viewvc?view=revision&revision=300002
# http://svn.php.net/viewvc?view=revision&revision=300089
# http://svn.php.net/viewvc?view=revision&revision=300646
# http://svn.php.net/viewvc?view=revision&revision=300791
Patch94: php-5.3.7-pdo-dblib-50755.patch






BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires: bzip2-devel, curl-devel >= 7.9, db4-devel, gmp-devel
BuildRequires: httpd-devel >= 2.0.46-1, pam-devel
BuildRequires: libstdc++-devel, openssl-devel
%if 0%{?fedora} >= 9 || 0%{?rhel} >= 6
# For Sqlite3 extension
BuildRequires: sqlite-devel >= 3.5.9
%else
BuildRequires: sqlite-devel >= 3.0.0
%endif
BuildRequires: zlib-devel, smtpdaemon, libedit-devel
%if 0%{?fedora} >= 10 || 0%{?rhel} >= 6
BuildRequires: pcre-devel >= 7.8
%endif
BuildRequires: bzip2, perl, libtool >= 1.4.3, gcc-c++
Obsoletes: php-mhash
Conflicts: php-zend-optimizer

%if 0%{?rhel}%{?fedora} > 4
BuildRequires: libtool-ltdl-devel
%endif

Obsoletes: %{phpname}-dbg, php3, phpfi, stronghold-php, %{phpname}-zts
Provides: %{phpname}-zts = %{version}-%{release}
Provides: %{phpname}-zts%{?_isa} = %{version}-%{release}

Requires: httpd-mmn = %{httpd_mmn}
Provides: mod_php = %{version}-%{release}
Requires: %{phpname}-common%{?_isa} = %{version}-%{release}
# For backwards-compatibility, require php-cli for the time being:
Requires: %{phpname}-cli%{?_isa} = %{version}-%{release}
# To ensure correct /var/lib/php/session ownership:
Requires(pre): httpd

# php53
Obsoletes: php53



%{expand: %%define _origbindir %{_bindir}}
%{expand: %%define _originitdir %{_initrddir}}
%{expand: %%define _origincludedir %{_includedir}}
%{expand: %%define _origsysconfdir %{_sysconfdir}}
%if %{phpname} == php
%global peardir      %{_datadir}/pear
%else
%global _bindir      /usr/bin/%{phpname}
%global _includedir  /usr/include/%{phpname}
%global _sysconfdir  /etc/%{phpname}
%global peardir      %{_datadir}/%{phpname}/pear
%endif

# RPM 4.8
%{?filter_provides_in: %filter_provides_in %{_libdir}/%{phpname}/modules/.*\.so$}
%{?filter_provides_in: %filter_provides_in %{_libdir}/%{phpname}-zts/modules/.*\.so$}
%{?filter_setup}
# RPM 4.9
%global __provides_exclude_from %{?__provides_exclude_from:%__provides_exclude_from|}%{_libdir}/%{phpname}/modules/.*\\.so$
%global __provides_exclude_from %{__provides_exclude_from}|%{_libdir}/%{phpname}-zts/modules/.*\\.so$



%description
PHP is an HTML-embedded scripting language. PHP attempts to make it
easy for developers to write dynamically generated web pages. PHP also
offers built-in database integration for several commercial and
non-commercial database management systems, so writing a
database-enabled webpage with PHP is fairly simple. The most common
use of PHP coding is probably as a replacement for CGI scripts. 

The php package contains the module which adds support for the PHP
language to Apache HTTP Server.

%package cli
Group: Development/Languages
Summary: Command-line interface for PHP
Requires: %{phpname}-common%{?_isa} = %{version}-%{release}
Provides: %{phpname}-cgi = %{version}-%{release}, %{phpname}-cgi%{?_isa} = %{version}-%{release}
Provides: %{phpname}-pcntl, %{phpname}-pcntl%{?_isa}
Provides: %{phpname}-readline, %{phpname}-readline%{?_isa}
# php53 overlap
Obsoletes: php53-cli

%description cli
The %{phpname}-cli package contains the command-line interface 
executing PHP scripts, /usr/bin/php, and the CGI interface.

%if %{with_fpm}
%package fpm
Group: Development/Languages
Summary: PHP FastCGI Process Manager
Requires: %{phpname}-common%{?_isa} = %{version}-%{release}
%if 0%{?fedora} >= 15
Requires: systemd-units
%endif
BuildRequires: libevent-devel >= 1.4.11

%description fpm
PHP-FPM (FastCGI Process Manager) is an alternative PHP FastCGI
implementation with some additional features useful for sites of
any size, especially busier sites.
%endif

%package common
Group: Development/Languages
Summary: Common files for PHP
# Remove this when value change
Provides: %{phpname}-api = %{apiver}, %{phpname}-zend-abi = %{zendver}
Provides: %{phpname}(api) = %{apiver}, %{phpname}(zend-abi) = %{zendver}
# New ABI/API check - Arch specific
Provides: %{phpname}-api = %{apiver}%{isasuffix}, %{phpname}-zend-abi = %{zendver}%{isasuffix}
Provides: %{phpname}(api) = %{apiver}%{isasuffix}, %{phpname}(zend-abi) = %{zendver}%{isasuffix}
# Provides for all builtin/shared modules:
Provides: %{phpname}-bz2, %{phpname}-bz2%{?_isa}
Provides: %{phpname}-calendar, %{phpname}-calendar%{?_isa}
Provides: %{phpname}-ctype, %{phpname}-ctype%{?_isa}
Provides: %{phpname}-curl, %{phpname}-curl%{?_isa}
Provides: %{phpname}-date, %{phpname}-date%{?_isa}
Provides: %{phpname}-exif, %{phpname}-exif%{?_isa}
Provides: %{phpname}-fileinfo, %{phpname}-fileinfo%{?_isa}
Provides: %{phpname}-pecl-Fileinfo = %{fileinfover}, %{phpname}-pecl-Fileinfo%{?_isa} = %{fileinfover}
Provides: %{phpname}-pecl(Fileinfo) = %{fileinfover}, %{phpname}-pecl(Fileinfo)%{?_isa} = %{fileinfover}
Provides: %{phpname}-ftp, %{phpname}-ftp%{?_isa}
Provides: %{phpname}-gettext, %{phpname}-gettext%{?_isa}
Provides: %{phpname}-gmp, %{phpname}-gmp%{?_isa}
Provides: %{phpname}-hash, %{phpname}-hash%{?_isa}
Provides: %{phpname}-mhash = %{version}, %{phpname}-mhash%{?_isa} = %{version}
Provides: %{phpname}-iconv, %{phpname}-iconv%{?_isa}
Provides: %{phpname}-json, %{phpname}-json%{?_isa}
Provides: %{phpname}-pecl-json = %{jsonver}, %{phpname}-pecl-json%{?_isa} = %{jsonver}
Provides: %{phpname}-pecl(json) = %{jsonver}, %{phpname}-pecl(json)%{?_isa} = %{jsonver}
Provides: %{phpname}-libxml, %{phpname}-libxml%{?_isa}
Provides: %{phpname}-openssl, %{phpname}-openssl%{?_isa}
Provides: %{phpname}-pecl-phar = %{pharver}, %{phpname}-pecl-phar%{?_isa} = %{pharver}
Provides: %{phpname}-pecl(phar) = %{pharver}, %{phpname}-pecl(phar)%{?_isa} = %{pharver}
Provides: %{phpname}-pcre, %{phpname}-pcre%{?_isa}
Provides: %{phpname}-reflection, %{phpname}-reflection%{?_isa}
Provides: %{phpname}-session, %{phpname}-session%{?_isa}
Provides: %{phpname}-shmop, %{phpname}-shmop%{?_isa}
Provides: %{phpname}-simplexml, %{phpname}-simplexml%{?_isa}
Provides: %{phpname}-sockets, %{phpname}-sockets%{?_isa}
Provides: %{phpname}-spl, %{phpname}-spl%{?_isa}
Provides: %{phpname}-tokenizer, %{phpname}-tokenizer%{?_isa}
%if %{with_zip}
Provides: %{phpname}-zip, %{phpname}-zip%{?_isa}
Provides: %{phpname}-pecl-zip = %{zipver}, %{phpname}-pecl-zip%{?_isa} = %{zipver}
Provides: %{phpname}-pecl(zip) = %{zipver}, %{phpname}-pecl(zip)%{?_isa} = %{zipver}
Obsoletes: %{phpname}-pecl-zip
%endif
Provides: %{phpname}-zlib, %{phpname}-zlib%{?_isa}
Obsoletes: %{phpname}-openssl, %{phpname}-pecl-json, %{phpname}-json, %{phpname}-pecl-phar, %{phpname}-pecl-Fileinfo

# php53 overlap
Provides: php53-common
Obsoletes: php53-common
Obsoletes: %{phpname}-mhash < 5.3.0

%description common
The %{phpname}-common package contains files used by both the php
package and the %{phpname}-cli package.

%package devel
Group: Development/Libraries
Summary: Files needed for building PHP extensions
Requires: %{phpname}%{?_isa} = %{version}-%{release}, autoconf, automake
Obsoletes: %{phpname}-pecl-pdo-devel
# php53 overlap
Obsoletes: php53-devel
Provides: php-zts-devel = %{version}-%{release}
Provides: php-zts-devel%{?_isa} = %{version}-%{release}


%description devel
The %{phpname}-devel package contains the files needed for building PHP
extensions. If you need to compile your own PHP extensions, you will
need to install this package.

%package imap
Summary: A module for PHP applications that use IMAP
Group: Development/Languages
Requires: %{phpname}-common%{?_isa} = %{version}-%{release}
Obsoletes: mod_php3-imap, stronghold-php-imap
BuildRequires: krb5-devel, openssl-devel, libc-client-devel
# php53 overlap
Obsoletes: php53-imap

%description imap
The %{phpname}-imap package contains a dynamic shared object (DSO) for the
Apache Web server. When compiled into Apache, the %{phpname}-imap module will
add IMAP (Internet Message Access Protocol) support to PHP. IMAP is a
protocol for retrieving and uploading e-mail messages on mail
servers. PHP is an HTML-embedded scripting language. If you need IMAP
support for PHP applications, you will need to install this package
and the php package.

%package ldap
Summary: A module for PHP applications that use LDAP
Group: Development/Languages
Requires: %{phpname}-common%{?_isa} = %{version}-%{release}
Obsoletes: mod_php3-ldap, stronghold-php-ldap
BuildRequires: cyrus-sasl-devel, openldap-devel, openssl-devel
Obsoletes: php53-ldap

%description ldap
The %{phpname}-ldap package is a dynamic shared object (DSO) for the Apache
Web server that adds Lightweight Directory Access Protocol (LDAP)
support to PHP. LDAP is a set of protocols for accessing directory
services over the Internet. PHP is an HTML-embedded scripting
language. If you need LDAP support for PHP applications, you will
need to install this package in addition to the php package.

%package pdo
Summary: A database access abstraction module for PHP applications
Group: Development/Languages
Requires: %{phpname}-common%{?_isa} = %{version}-%{release}
Obsoletes: %{phpname}-pecl-pdo-sqlite, %{phpname}-pecl-pdo
# Remove this when value change
Provides: %{phpname}-pdo-abi = %{pdover}
# New ABI/API check - Arch specific
Provides: %{phpname}-pdo-abi = %{pdover}%{isasuffix}
Provides: %{phpname}-sqlite3, %{phpname}-sqlite3%{?_isa}
Provides: %{phpname}-pdo_sqlite, %{phpname}-pdo_sqlite%{?_isa}
Obsoletes: php53-pdo

%description pdo
The %{phpname}-pdo package contains a dynamic shared object that will add
a database access abstraction layer to PHP.  This module provides
a common interface for accessing MySQL, PostgreSQL or other 
databases.

%package sqlite
Summary: Extension for the SQLite V2 Embeddable SQL Database Engine
Group: Development/Languages
BuildRequires: sqlite2-devel >= 2.8.0
Requires: %{phpname}-common%{?_isa} = %{version}-%{release}
Obsoletes: %{phpname}-sqlite2
Provides: %{phpname}-sqlite2, %{phpname}-sqlite2%{?_isa}
# Plesk dependency
Provides: any-php-sqlite2
Provides: %{phpname}-sqlite2 = %{version}-%{release}
Provides: %{phpname}-sqlite2%{?_isa} = %{version}-%{release}
Obsoletes: php53-sqlite php53-sqlite2
Provides: php53-sqlite php53-sqlite2


%description sqlite
This is an extension for the SQLite Embeddable SQL Database Engine. 
SQLite is a C library that implements an embeddable SQL database engine. 
Programs that link with the SQLite library can have SQL database access 
without running a separate RDBMS process. 

%package mysql
Summary: A module for PHP applications that use MySQL databases
Group: Development/Languages
Requires: %{phpname}-pdo%{?_isa} = %{version}-%{release}
Provides: %{phpname}_database
Provides: %{phpname}-mysqli = %{version}-%{release}
Provides: %{phpname}-mysqli%{?_isa} = %{version}-%{release}
Provides: %{phpname}-pdo_mysql, %{phpname}-pdo_mysql%{?_isa}
Obsoletes: mod_php3-mysql, stronghold-php-mysql
BuildRequires: mysql-devel >= 4.1.0
Obsoletes: php53-mysql
Conflicts: %{phpname}-mysqlnd


%description mysql
The %{phpname}-mysql package contains a dynamic shared object that will add
MySQL database support to PHP. MySQL is an object-relational database
management system. PHP is an HTML-embeddable scripting language. If
you need MySQL support for PHP applications, you will need to install
this package and the php package.

%package mysqlnd
Summary: A module for PHP applications that use MySQL databases
Group: Development/Languages
Requires: %{phpname}-pdo%{?_isa} = %{version}-%{release}
Provides: %{phpname}_database
Provides: %{phpname}-mysql = %{version}-%{release}
Provides: %{phpname}-mysql%{?_isa} = %{version}-%{release}
Provides: %{phpname}-mysqli = %{version}-%{release}
Provides: %{phpname}-mysqli%{?_isa} = %{version}-%{release}
Provides: %{phpname}-pdo_mysql, %{phpname}-pdo_mysql%{?_isa}

%description mysqlnd
The %{phpname}-mysqlnd package contains a dynamic shared object that will add
MySQL database support to PHP. MySQL is an object-relational database
management system. PHP is an HTML-embeddable scripting language. If
you need MySQL support for PHP applications, you will need to install
this package and the php package.

This package use the MySQL Native Driver



%package pgsql
Summary: A PostgreSQL database module for PHP
Group: Development/Languages
Requires: %{phpname}-pdo%{?_isa} = %{version}-%{release}
Provides: %{phpname}_database
Provides: %{phpname}-pdo_pgsql, %{phpname}-pdo_pgsql%{?_isa}
Obsoletes: mod_php3-pgsql, stronghold-php-pgsql
BuildRequires: krb5-devel, openssl-devel, postgresql-devel
Obsoletes: php53-pgsql

%description pgsql
The %{phpname}-pgsql package includes a dynamic shared object (DSO) that can
be compiled in to the Apache Web server to add PostgreSQL database
support to PHP. PostgreSQL is an object-relational database management
system that supports almost all SQL constructs. PHP is an
HTML-embedded scripting language. If you need back-end support for
PostgreSQL, you should install this package in addition to the main
php package.

%package process
Summary: Modules for PHP script using system process interfaces
Group: Development/Languages
Requires: %{phpname}-common%{?_isa} = %{version}-%{release}
Provides: %{phpname}-posix, %{phpname}-posix%{?_isa}
Provides: %{phpname}-sysvsem, %{phpname}-sysvsem%{?_isa}
Provides: %{phpname}-sysvshm, %{phpname}-sysvshm%{?_isa}
Provides: %{phpname}-sysvmsg, %{phpname}-sysvmsg%{?_isa}
Obsoletes: php53-process

%description process
The %{phpname}-process package contains dynamic shared objects which add
support to PHP using system interfaces for inter-process
communication.

%package odbc
Group: Development/Languages
Requires: %{phpname}-pdo%{?_isa} = %{version}-%{release}
Summary: A module for PHP applications that use ODBC databases
Provides: %{phpname}_database
Provides: %{phpname}-pdo_odbc, %{phpname}-pdo_odbc%{?_isa}
Obsoletes: stronghold-php-odbc
BuildRequires: unixODBC-devel
Obsoletes: php53-odbc

%description odbc
The %{phpname}-odbc package contains a dynamic shared object that will add
database support through ODBC to PHP. ODBC is an open specification
which provides a consistent API for developers to use for accessing
data sources (which are often, but not always, databases). PHP is an
HTML-embeddable scripting language. If you need ODBC support for PHP
applications, you will need to install this package and the php
package.

%package soap
Group: Development/Languages
Requires: %{phpname}-common%{?_isa} = %{version}-%{release}
Summary: A module for PHP applications that use the SOAP protocol
BuildRequires: libxml2-devel
Obsoletes: php53-soap

%description soap
The %{phpname}-soap package contains a dynamic shared object that will add
support to PHP for using the SOAP web services protocol.

%if %{with_ibase}
%package interbase
Summary: 	A module for PHP applications that use Interbase/Firebird databases
Group: 		Development/Languages
BuildRequires:  firebird-devel
Requires:       %{phpname}-pdo%{?_isa} = %{version}-%{release}
Provides: 	%{phpname}_database
Provides: 	%{phpname}-firebird, %{phpname}-firebird%{?_isa}
Provides: 	%{phpname}-pdo_firebird, %{phpname}-pdo_firebird%{?_isa}

%description interbase
The %{phpname}-interbase package contains a dynamic shared object that will add
database support through Interbase/Firebird to PHP.

InterBase is the name of the closed-source variant of this RDBMS that was
developed by Borland/Inprise. 

Firebird is a commercially independent project of C and C++ programmers, 
technical advisors and supporters developing and enhancing a multi-platform 
relational database management system based on the source code released by 
Inprise Corp (now known as Borland Software Corp) under the InterBase Public
License.
%endif

%if %{with_oci8}
%package oci8
Summary: 	A module for PHP applications that use OCI8 databases
Group: 		Development/Languages
BuildRequires: 	oracle-instantclient-devel >= %{oraclever}
Requires:       %{phpname}-pdo%{?_isa} = %{version}-%{release}
Provides: 	%{phpname}_database 
Provides: 	%{phpname}-pdo_oci = %{oci8ver}, %{phpname}-pdo_oci%{?_isa} = %{oci8ver}
Provides:       %{phpname}-pecl-oci8 = %{oci8ver}, %{phpname}-pecl-oci8%{?_isa} = %{oci8ver}
Provides:       %{phpname}-pecl(oci8) = %{oci8ver}, %{phpname}-pecl(oci8)%{?_isa} = %{oci8ver}
# Should requires libclntsh.so.11.1, but it's not provided by Oracle RPM.
AutoReq: 	0

%description oci8
The %{phpname}-oci8 package contains a dynamic shared object that will add
support for accessing OCI8 databases to PHP.
%endif

%package snmp
Summary: A module for PHP applications that query SNMP-managed devices
Group: Development/Languages
Requires: %{phpname}-common%{?_isa} = %{version}-%{release}, net-snmp
BuildRequires: net-snmp-devel
Obsoletes: php53-snmp

%description snmp
The %{phpname}-snmp package contains a dynamic shared object that will add
support for querying SNMP devices to PHP.  PHP is an HTML-embeddable
scripting language. If you need SNMP support for PHP applications, you
will need to install this package and the php package.

%package xml
Summary: A module for PHP applications which use XML
Group: Development/Languages
Requires: %{phpname}-common%{?_isa} = %{version}-%{release}
Obsoletes: %{phpname}-domxml, %{phpname}-dom
Provides: %{phpname}-dom, %{phpname}-dom%{?_isa}
Provides: %{phpname}-xsl, %{phpname}-xsl%{?_isa}
Provides: %{phpname}-domxml, %{phpname}-domxml%{?_isa}
Provides: %{phpname}-wddx, %{phpname}-wddx%{?_isa}
BuildRequires: libxslt-devel >= 1.0.18-1, libxml2-devel >= 2.4.14-1
Obsoletes: php53-xml

%description xml
The %{phpname}-xml package contains dynamic shared objects which add support
to PHP for manipulating XML documents using the DOM tree,
and performing XSL transformations on XML documents.

%package xmlrpc
Summary: A module for PHP applications which use the XML-RPC protocol
Group: Development/Languages
Requires: %{phpname}-common%{?_isa} = %{version}-%{release}
Obsoletes: php53-xmlrpc

%description xmlrpc
The %{phpname}-xmlrpc package contains a dynamic shared object that will add
support for the XML-RPC protocol to PHP.

%package mbstring
Summary: A module for PHP applications which need multi-byte string handling
Group: Development/Languages
Requires: %{phpname}-common%{?_isa} = %{version}-%{release}
Obsoletes: php53-mbstring

%description mbstring
The %{phpname}-mbstring package contains a dynamic shared object that will add
support for multi-byte string handling to PHP.

%package gd
Summary: A module for PHP applications for using the gd graphics library
Group: Development/Languages
Requires: %{phpname}-common%{?_isa} = %{version}-%{release}
# Required to build the bundled GD library
BuildRequires: libjpeg-devel, libpng-devel, freetype-devel
%if 0%{?rhel}%{?fedora} > 4
BuildRequires: libXpm-devel, t1lib-devel
%else
BuildRequires: xorg-x11-devel
%endif
#php53 overlap
Obsoletes: php53-gd

%description gd
The %{phpname}-gd package contains a dynamic shared object that will add
support for using the gd graphics library to PHP.

%package bcmath
Summary: A module for PHP applications for using the bcmath library
Group: Development/Languages
Requires: %{phpname}-common%{?_isa} = %{version}-%{release}
Obsoletes: php53-bcmath

%description bcmath
The %{phpname}-bcmath package contains a dynamic shared object that will add
support for using the bcmath library to PHP.

%package dba
Summary: A database abstraction layer module for PHP applications
Group: Development/Languages
Requires: %{phpname}-pdo%{?_isa} = %{version}-%{release}
# php53 overlap
Obsoletes: php53-dba

%description dba
The %{phpname}-dba package contains a dynamic shared object that will add
support for using the DBA database abstraction layer to PHP.

%package mcrypt
Summary: Standard PHP module provides mcrypt library support
Group: Development/Languages
Requires: %{phpname}-common%{?_isa} = %{version}-%{release}
BuildRequires: libmcrypt-devel

%description mcrypt
The %{phpname}-mcrypt package contains a dynamic shared object that will add
support for using the mcrypt library to PHP.

%package tidy
Summary: Standard PHP module provides tidy library support
Group: Development/Languages
Requires: %{phpname}-common%{?_isa} = %{version}-%{release}
BuildRequires: libtidy-devel

%description tidy
The %{phpname}-tidy package contains a dynamic shared object that will add
support for using the tidy library to PHP.

%package mssql
Summary: MSSQL database module for PHP
Group: Development/Languages
Requires: %{phpname}-common%{?_isa} = %{version}-%{release}, %{phpname}-pdo%{?_isa}
BuildRequires: freetds-devel
Provides: %{phpname}-pdo_dblib, %{phpname}-pdo_dblib%{?_isa}

%description mssql
The %{phpname}-mssql package contains a dynamic shared object that will
add MSSQL database support to PHP.  It uses the TDS (Tabular
DataStream) protocol through the freetds library, hence any
database server which supports TDS can be accessed.

%package embedded
Summary: PHP library for embedding in applications
Group: System Environment/Libraries
Requires: %{phpname}-common%{?_isa} = %{version}-%{release}
# doing a real -devel package for just the .so symlink is a bit overkill
Provides: %{phpname}-embedded-devel = %{version}-%{release}
Provides: %{phpname}-embedded-devel%{?_isa} = %{version}-%{release}

%description embedded
The %{phpname}-embedded package contains a library which can be embedded
into applications to provide PHP scripting language support.

%package pspell
Summary: A module for PHP applications for using pspell interfaces
Group: System Environment/Libraries
Requires: %{phpname}-common%{?_isa} = %{version}-%{release}
BuildRequires: aspell-devel >= 0.50.0
Obsoletes: php53-pspell

%description pspell
The %{phpname}-pspell package contains a dynamic shared object that will add
support for using the pspell library to PHP.

%package recode
Summary: A module for PHP applications for using the recode library
Group: System Environment/Libraries
Requires: %{phpname}-common%{?_isa} = %{version}-%{release}
BuildRequires: recode-devel

%description recode
The %{phpname}-recode package contains a dynamic shared object that will add
support for using the recode library to PHP.

%package intl
Summary: Internationalization extension for PHP applications
Group: System Environment/Libraries
Requires: %{phpname}-common%{?_isa} = %{version}-%{release}
BuildRequires: libicu-devel >= 3.6
Obsoletes: php53-intl

%description intl
The %{phpname}-intl package contains a dynamic shared object that will add
support for using the ICU library to PHP.

%if %{with_enchant}
%package enchant
Summary: Human Language and Character Encoding Support
Group: System Environment/Libraries
Requires: %{phpname}-common%{?_isa} = %{version}-%{release}
BuildRequires: enchant-devel >= 1.2.4

%description enchant
The %{phpname}-intl package contains a dynamic shared object that will add
support for using the enchant library to PHP.
%endif


%prep
echo CIBLE = %{name}-%{version}-%{release}
%setup -q -n php-%{version}
%patch1 -p1 -b .gnusrc
%patch2 -p1 -b .install
%patch3 -p1 -b .norpath
%patch5 -p1 -b .includedir
%patch6 -p1 -b .embed
%patch7 -p1 -b .recode
%if 0%{?fedora} >= 6 || 0%{?rhel} >= 5
%patch8 -p1 -b .aconf259
%endif
%patch9 -p1 -b .mysqlnd

%patch20 -p1 -b .shutdown
%patch21 -p1 -b .macropen

%patch40 -p1 -b .dlopen
%patch41 -p1 -b .easter
%if %{?fedora}%{?rhel:99} >= 13
%patch42 -p1 -b .systzdata
%endif
%patch43 -p0 -b .headers

%patch61 -p1 -b .tests-wddx
%patch62 -p0 -b .tests

%patch91 -p1 -b .remi-oci8
%patch92 -p1 -b .libedit
%if 0%{?rhel} == 4
%patch93 -p1 -b .mysqli
%endif
%patch94 -p1 -b .50755


# Prevent %%doc confusion over LICENSE files
cp Zend/LICENSE Zend/ZEND_LICENSE
cp TSRM/LICENSE TSRM_LICENSE
cp ext/ereg/regex/COPYRIGHT regex_COPYRIGHT
cp ext/gd/libgd/README gd_README

# Multiple builds for multiple SAPIs
mkdir build-cgi build-apache build-embedded build-zts \
%if %{with_fpm}
    build-fpm
%endif

# Remove bogus test; position of read position after fopen(, "a+")
# is not defined by C standard, so don't presume anything.
rm -f ext/standard/tests/file/bug21131.phpt
# php_egg_logo_guid() removed by patch41
rm -f tests/basic/php_egg_logo_guid.phpt

# Tests that fail.
rm -f ext/standard/tests/file/bug22414.phpt \
      ext/iconv/tests/bug16069.phpt

# Safety check for API version change.
pver=$(sed -n '/#define PHP_VERSION /{s/.* "//;s/".*$//;p}' main/php_version.h)
if test "x${pver}" != "x%{phpversion}"; then
   : Error: Upstream PHP version is now ${pver}, expecting %{phpversion}.
   : Update the phpversion macro and rebuild.
   exit 1
fi

vapi=`sed -n '/#define PHP_API_VERSION/{s/.* //;p}' main/php.h`
if test "x${vapi}" != "x%{apiver}"; then
   : Error: Upstream API version is now ${vapi}, expecting %{apiver}.
   : Update the apiver macro and rebuild.
   exit 1
fi

vzend=`sed -n '/#define ZEND_MODULE_API_NO/{s/^[^0-9]*//;p;}' Zend/zend_modules.h`
if test "x${vzend}" != "x%{zendver}"; then
   : Error: Upstream Zend ABI version is now ${vzend}, expecting %{zendver}.
   : Update the zendver macro and rebuild.
   exit 1
fi

# Safety check for PDO ABI version change
vpdo=`sed -n '/#define PDO_DRIVER_API/{s/.*[ 	]//;p}' ext/pdo/php_pdo_driver.h`
if test "x${vpdo}" != "x%{pdover}"; then
   : Error: Upstream PDO ABI version is now ${vpdo}, expecting %{pdover}.
   : Update the pdover macro and rebuild.
   exit 1
fi

# Check for some extension version
ver=$(sed -n '/#define PHP_FILEINFO_VERSION /{s/.* "//;s/".*$//;p}' ext/fileinfo/php_fileinfo.h)
if test "$ver" != "%{fileinfover}"; then
   : Error: Upstream FILEINFO version is now ${ver}, expecting %{fileinfover}.
   : Update the fileinfover macro and rebuild.
   exit 1
fi
ver=$(sed -n '/#define PHP_PHAR_VERSION /{s/.* "//;s/".*$//;p}' ext/phar/php_phar.h)
if test "$ver" != "%{pharver}"; then
   : Error: Upstream PHAR version is now ${ver}, expecting %{pharver}.
   : Update the pharver macro and rebuild.
   exit 1
fi
ver=$(sed -n '/#define PHP_ZIP_VERSION_STRING /{s/.* "//;s/".*$//;p}' ext/zip/php_zip.h)
if test "$ver" != "%{zipver}"; then
   : Error: Upstream ZIP version is now ${ver}, expecting %{zipver}.
   : Update the zipver macro and rebuild.
   exit 1
fi
ver=$(sed -n '/#define PHP_OCI8_VERSION /{s/.* "//;s/".*$//;p}' ext/oci8/php_oci8.h)
if test "$ver" != "%{oci8ver}"; then
   : Error: Upstream OCI8 version is now ${ver}, expecting %{oci8ver}.
   : Update the oci8ver macro and rebuild.
   exit 1
fi
ver=$(sed -n '/#define PHP_JSON_VERSION /{s/.* "//;s/".*$//;p}' ext/json/php_json.h)
if test "$ver" != "%{jsonver}"; then
   : Error: Upstream JSON version is now ${ver}, expecting %{jsonver}.
   : Update the jsonver macro and rebuild.
   exit 1
fi

# Fix some bogus permissions
find . -name \*.[ch] -exec chmod 644 {} \;
chmod 644 README.*

# php-fpm configuration files for tmpfiles.d
echo "d %{_localstatedir}/run/php-fpm 755 root root" >php-fpm.tmpfiles

: Build for oci8=%{with_oci8} ibase=%{with_ibase}


%build
%if 0%{?fedora} >= 11 || 0%{?rhel} >= 6
# aclocal workaround - to be improved
cat `aclocal --print-ac-dir`/{libtool,ltoptions,ltsugar,ltversion,lt~obsolete}.m4 >>aclocal.m4
%endif

# Force use of system libtool:
libtoolize --force --copy
%if 0%{?fedora} >= 11 || 0%{?rhel} >= 6
cat `aclocal --print-ac-dir`/{libtool,ltoptions,ltsugar,ltversion,lt~obsolete}.m4 >build/libtool.m4
%else
cat `aclocal --print-ac-dir`/libtool.m4 > build/libtool.m4
%endif

# Regenerate configure scripts (patches change config.m4's)
touch configure.in
./buildconf --force
CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing -Wno-pointer-sign"
%if 0%{?rhel} < 5
	CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing"
%endif
export CFLAGS

# Install extension modules in %{_libdir}/php/modules.
EXTENSION_DIR=%{_libdir}/%{phpname}/modules; export EXTENSION_DIR

# Set PEAR_INSTALLDIR to ensure that the hard-coded include_path
# includes the PEAR directory even though pear is packaged
# separately.
PEAR_INSTALLDIR=%{peardir}; export PEAR_INSTALLDIR

# Shell function to configure and build a PHP tree.
build() {
# bison-1.875-2 seems to produce a broken parser; workaround.
mkdir Zend && cp ../Zend/zend_{language,ini}_{parser,scanner}.[ch] Zend
ln -sf ../configure
%configure \
	--cache-file=../config.cache \
        --with-libdir=%{_lib} \
	--with-config-file-path=%{_sysconfdir} \
	--with-config-file-scan-dir=%{_sysconfdir}/php.d \
	--disable-debug \
	--with-pic \
	--disable-rpath \
	--without-pear \
	--with-bz2 \
	--with-exec-dir=%{_bindir} \
	--with-freetype-dir=%{_prefix} \
	--with-png-dir=%{_prefix} \
	--with-xpm-dir=%{_prefix} \
	--enable-gd-native-ttf \
%if 0%{?rhel}%{?fedora} > 4
	--with-t1lib=%{_prefix} \
%endif
	--without-gdbm \
	--with-gettext \
	--with-gmp \
	--with-iconv \
	--with-jpeg-dir=%{_prefix} \
	--with-openssl \
        --with-pcre-regex \
	--with-zlib \
	--with-layout=GNU \
	--enable-exif \
	--enable-ftp \
	--enable-magic-quotes \
	--enable-sockets \
	--with-kerberos \
	--enable-ucd-snmp-hack \
	--enable-shmop \
	--enable-calendar \
        --with-libxml-dir=%{_prefix} \
	--enable-xml \
%if %{?fedora}%{?rhel:99} >= 10
        --with-system-tzdata \
%endif
	--with-mhash \
	$* 
if test $? != 0; then 
  tail -500 config.log
  : configure failed
  exit 1
fi

make %{?_smp_mflags}
}

# Build /usr/bin/php-cgi with the CGI SAPI, and all the shared extensions
pushd build-cgi

# RC patch ??? (only for EL-5 ??)
mkdir -p ext/sqlite/libsqlite/src
cp ../ext/sqlite/libsqlite/src/encode.c ext/sqlite/libsqlite/src/

build --enable-force-cgi-redirect \
      --libdir=%{_libdir}/%{phpname} \
      --enable-pcntl \
      --with-imap=shared --with-imap-ssl \
      --enable-mbstring=shared \
      --enable-mbregex \
      --with-gd=shared \
      --enable-bcmath=shared \
      --enable-dba=shared --with-db4=%{_prefix} \
      --with-xmlrpc=shared \
      --with-ldap=shared --with-ldap-sasl \
      --enable-mysqlnd=shared \
      --with-mysql=shared,mysqlnd \
      --with-mysqli=shared,mysqlnd \
%ifarch x86_64
      %{?_with_oci8:--with-oci8=shared,instantclient,%{_libdir}/oracle/%{oraclever}/client64/lib,%{oraclever}} \
%else
      %{?_with_oci8:--with-oci8=shared,instantclient,%{_libdir}/oracle/%{oraclever}/client/lib,%{oraclever}} \
%endif
      %{?_with_oci8:--with-pdo-oci=shared,instantclient,/usr,%{oraclever}} \
      %{?_with_ibase:--with-interbase=shared,%{_libdir}/firebird} \
      %{?_with_ibase:--with-pdo-firebird=shared,%{_libdir}/firebird} \
      --enable-dom=shared \
      --with-pgsql=shared \
      --enable-wddx=shared \
      --with-snmp=shared,%{_prefix} \
      --enable-soap=shared \
      --with-xsl=shared,%{_prefix} \
      --enable-xmlreader=shared --enable-xmlwriter=shared \
      --with-curl=shared,%{_prefix} \
      --enable-fastcgi \
      --enable-pdo=shared \
      --with-pdo-odbc=shared,unixODBC,%{_prefix} \
      --with-pdo-mysql=shared,mysqlnd \
      --with-pdo-pgsql=shared,%{_prefix} \
      --with-pdo-sqlite=shared,%{_prefix} \
      --with-pdo-dblib=shared,%{_prefix} \
%if 0%{?fedora} >= 9 || 0%{?rhel} >= 6
      --with-sqlite3=shared,%{_prefix} \
%else
      --without-sqlite3 \
%endif
      --with-sqlite=shared,%{_prefix} \
      --enable-json=shared \
%if %{with_zip}
      --enable-zip=shared \
%endif
      --without-readline \
      --with-libedit \
      --with-pspell=shared \
      --enable-phar=shared \
      --with-mcrypt=shared,%{_prefix} \
      --with-tidy=shared,%{_prefix} \
      --with-mssql=shared,%{_prefix} \
      --enable-sysvmsg=shared --enable-sysvshm=shared --enable-sysvsem=shared \
      --enable-posix=shared \
      --with-unixODBC=shared,%{_prefix} \
      --enable-fileinfo=shared \
      --enable-intl=shared \
      --with-icu-dir=%{_prefix} \
%if %{with_enchant}
      --with-enchant=shared,%{_prefix} \
%endif
      --with-recode=shared,%{_prefix}
popd

without_shared="--without-gd \
      --disable-dom --disable-dba --without-unixODBC \
      --disable-xmlreader --disable-xmlwriter \
      --without-sqlite \
      --without-sqlite3 --disable-phar --disable-fileinfo \
      --disable-json --without-pspell --disable-wddx \
      --without-curl --disable-posix \
      --disable-sysvmsg --disable-sysvshm --disable-sysvsem"

# Build Apache module, and the CLI SAPI, /usr/bin/php
pushd build-apache
build --with-apxs2=%{_sbindir}/apxs \
      --libdir=%{_libdir}/%{phpname} \
      --enable-pdo=shared \
      --with-mysql=shared,%{_prefix} \
      --with-mysqli=shared,%{mysql_config} \
      --with-pdo-mysql=shared,%{mysql_config} \
      --with-pdo-sqlite=shared,%{_prefix} \
      ${without_shared}
popd

%if %{with_fpm}
# Build php-fpm
pushd build-fpm
build --enable-fpm \
      --libdir=%{_libdir}/%{phpname} \
      --without-mysql --disable-pdo \
      ${without_shared}
popd
%endif

# Build for inclusion as embedded script language into applications,
# /usr/lib[64]/libphp5.so
pushd build-embedded
build --enable-embed \
      --without-mysql --disable-pdo \
      ${without_shared}
popd

# Build a special thread-safe Apache SAPI
pushd build-zts

# RC patch ??? (only for EL-5 ??)
mkdir -p ext/sqlite/libsqlite/src
cp ../ext/sqlite/libsqlite/src/encode.c ext/sqlite/libsqlite/src/

EXTENSION_DIR=%{_libdir}/%{phpname}-zts/modules
build --with-apxs2=%{_sbindir}/apxs \
      --bindir=%{_origbindir}/%{phpname}-zts \
      --includedir=%{_origincludedir}/%{phpname}-zts \
      --libdir=%{_libdir}/%{phpname}-zts \
      --enable-maintainer-zts \
      --with-config-file-scan-dir=%{_sysconfdir}/php-zts.d \
      --enable-force-cgi-redirect \
      --enable-pcntl \
      --with-imap=shared --with-imap-ssl \
      --enable-mbstring=shared \
      --enable-mbregex \
      --with-gd=shared \
      --enable-bcmath=shared \
      --enable-dba=shared --with-db4=%{_prefix} \
      --with-xmlrpc=shared \
      --with-ldap=shared --with-ldap-sasl \
      --enable-mysqlnd=shared \
      --with-mysql=shared,mysqlnd \
      --with-mysqli=shared,mysqlnd \
      --enable-mysqlnd-threading \
%ifarch x86_64
      %{?_with_oci8:--with-oci8=shared,instantclient,%{_libdir}/oracle/%{oraclever}/client64/lib,%{oraclever}} \
%else
      %{?_with_oci8:--with-oci8=shared,instantclient,%{_libdir}/oracle/%{oraclever}/client/lib,%{oraclever}} \
%endif
      %{?_with_oci8:--with-pdo-oci=shared,instantclient,/usr,%{oraclever}} \
      %{?_with_ibase:--with-interbase=shared,%{_libdir}/firebird} \
      %{?_with_ibase:--with-pdo-firebird=shared,%{_libdir}/firebird} \
      --enable-dom=shared \
      --with-pgsql=shared \
      --enable-wddx=shared \
      --with-snmp=shared,%{_prefix} \
      --enable-soap=shared \
      --with-xsl=shared,%{_prefix} \
      --enable-xmlreader=shared --enable-xmlwriter=shared \
      --with-curl=shared,%{_prefix} \
      --enable-fastcgi \
      --enable-pdo=shared \
      --with-pdo-odbc=shared,unixODBC,%{_prefix} \
      --with-pdo-mysql=shared,mysqlnd \
      --with-pdo-pgsql=shared,%{_prefix} \
      --with-pdo-sqlite=shared,%{_prefix} \
      --with-pdo-dblib=shared,%{_prefix} \
%if 0%{?fedora} >= 9 || 0%{?rhel} >= 6
      --with-sqlite3=shared,%{_prefix} \
%else
      --without-sqlite3 \
%endif
      --with-sqlite=shared,%{_prefix} \
      --enable-json=shared \
%if %{with_zip}
      --enable-zip=shared \
%endif
      --without-readline \
      --with-libedit \
      --with-pspell=shared \
      --enable-phar=shared \
      --with-mcrypt=shared,%{_prefix} \
      --with-tidy=shared,%{_prefix} \
      --with-mssql=shared,%{_prefix} \
      --enable-sysvmsg=shared --enable-sysvshm=shared --enable-sysvsem=shared \
      --enable-posix=shared \
      --with-unixODBC=shared,%{_prefix} \
      --enable-fileinfo=shared \
      --enable-intl=shared \
      --with-icu-dir=%{_prefix} \
%if %{with_enchant}
      --with-enchant=shared,%{_prefix} \
%endif
      --with-recode=shared,%{_prefix}
popd

### NOTE!!! EXTENSION_DIR was changed for the -zts build, so it must remain
### the last SAPI to be built.

%check
%if %runselftest
cd build-apache
# Run tests, using the CLI SAPI
export NO_INTERACTION=1 REPORT_EXIT_STATUS=1 MALLOC_CHECK_=2
unset TZ LANG LC_ALL
if ! make test; then
  set +x
  for f in `find .. -name \*.diff -type f -print`; do
    echo "TEST FAILURE: $f --"
    cat "$f"
    echo "-- $f result ends."
  done
  set -x
  #exit 1
fi
unset NO_INTERACTION REPORT_EXIT_STATUS MALLOC_CHECK_
%endif

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

# Install the extensions for the ZTS version
make -C build-zts install-build install-programs install-headers install-modules \
     INSTALL_ROOT=$RPM_BUILD_ROOT

# rename extensions build with mysqlnd
mv $RPM_BUILD_ROOT%{_libdir}/%{phpname}-zts/modules/mysql.so \
   $RPM_BUILD_ROOT%{_libdir}/%{phpname}-zts/modules/mysqlnd_mysql.so
mv $RPM_BUILD_ROOT%{_libdir}/%{phpname}-zts/modules/mysqli.so \
   $RPM_BUILD_ROOT%{_libdir}/%{phpname}-zts/modules/mysqlnd_mysqli.so
mv $RPM_BUILD_ROOT%{_libdir}/%{phpname}-zts/modules/pdo_mysql.so \
   $RPM_BUILD_ROOT%{_libdir}/%{phpname}-zts/modules/pdo_mysqlnd.so


# Install the version for embedded script language in applications + php_embed.h
make -C build-embedded install-sapi install-headers \
     INSTALL_ROOT=$RPM_BUILD_ROOT


%if %{with_fpm}
# Install the php-fpm binary
make -C build-fpm install-fpm \
     INSTALL_ROOT=$RPM_BUILD_ROOT
%endif

# Install everything from the CGI SAPI build
make -C build-cgi install \
     INSTALL_ROOT=$RPM_BUILD_ROOT

# rename extensions build with mysqlnd
mv $RPM_BUILD_ROOT%{_libdir}/%{phpname}/modules/mysql.so \
   $RPM_BUILD_ROOT%{_libdir}/%{phpname}/modules/mysqlnd_mysql.so
mv $RPM_BUILD_ROOT%{_libdir}/%{phpname}/modules/mysqli.so \
   $RPM_BUILD_ROOT%{_libdir}/%{phpname}/modules/mysqlnd_mysqli.so
mv $RPM_BUILD_ROOT%{_libdir}/%{phpname}/modules/pdo_mysql.so \
   $RPM_BUILD_ROOT%{_libdir}/%{phpname}/modules/pdo_mysqlnd.so

# Install the mysql extension build with libmysql
make -C build-apache install-modules \
     INSTALL_ROOT=$RPM_BUILD_ROOT

# Install the default configuration file and icons
install -m 755 -d $RPM_BUILD_ROOT%{_sysconfdir}/
#install -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/php.ini
%{__sed} -e '/session.save_path/s/php/%{phpname}/' %{SOURCE2} >$RPM_BUILD_ROOT%{_sysconfdir}/php.ini
install -m 755 -d $RPM_BUILD_ROOT%{contentdir}/icons
install -m 644 php.gif $RPM_BUILD_ROOT%{contentdir}/icons/%{phpname}.gif

# For third-party packaging:
install -m 755 -d $RPM_BUILD_ROOT%{_datadir}/%{phpname}

# install the DSO
install -m 755 -d $RPM_BUILD_ROOT%{_libdir}/httpd/modules
%if %{phpname} == php
install -m 755 build-apache/libs/libphp5.so $RPM_BUILD_ROOT%{_libdir}/httpd/modules
%else
install -m 755 build-apache/libs/libphp5.so $RPM_BUILD_ROOT%{_libdir}/httpd/modules/lib%{phpname}.so
%endif

# install the ZTS DSO
%if %{phpname} == php
install -m 755 build-zts/libs/libphp5.so $RPM_BUILD_ROOT%{_libdir}/httpd/modules/libphp5-zts.so
%else
install -m 755 build-zts/libs/libphp5.so $RPM_BUILD_ROOT%{_libdir}/httpd/modules/lib%{phpname}-zts.so
%endif

# Apache config fragment
install -m 755 -d $RPM_BUILD_ROOT/%{_origsysconfdir}/httpd/conf.d
%if %{phpname} == php
install -m 644 %{SOURCE1} $RPM_BUILD_ROOT/%{_origsysconfdir}/httpd/conf.d
%else
%{__sed} -e s'/libphp5/lib%{phpname}/' %{SOURCE1} \
  >$RPM_BUILD_ROOT/%{_origsysconfdir}/httpd/conf.d/%{phpname}.conf
%endif

install -m 755 -d $RPM_BUILD_ROOT%{_sysconfdir}/php.d
install -m 755 -d $RPM_BUILD_ROOT%{_sysconfdir}/php-zts.d
install -m 755 -d $RPM_BUILD_ROOT%{_localstatedir}/lib/php
install -m 700 -d $RPM_BUILD_ROOT%{_localstatedir}/lib/%{phpname}/session

%if %{with_fpm}
# PHP-FPM stuff
# Log
install -m 755 -d $RPM_BUILD_ROOT%{_localstatedir}/log/php-fpm
install -m 755 -d $RPM_BUILD_ROOT%{_localstatedir}/run/php-fpm
# Config
install -m 755 -d $RPM_BUILD_ROOT%{_origsysconfdir}/php-fpm.d
install -m 644 %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/php-fpm.conf
install -m 644 %{SOURCE5} $RPM_BUILD_ROOT%{_origsysconfdir}/php-fpm.d/www.conf
mv $RPM_BUILD_ROOT%{_sysconfdir}/php-fpm.conf.default .
# Service
install -m 755 -d $RPM_BUILD_ROOT%{_originitdir}
install -m 755 %{SOURCE6} $RPM_BUILD_ROOT%{_originitdir}/php-fpm
# LogRotate
install -m 755 -d $RPM_BUILD_ROOT%{_origsysconfdir}/logrotate.d
install -m 644 %{SOURCE7} $RPM_BUILD_ROOT%{_origsysconfdir}/logrotate.d/php-fpm
%if 0%{?fedora} >= 15
# tmpfiles.d
install -m 755 -d $RPM_BUILD_ROOT%{_sysconfdir}/tmpfiles.d
install -m 644 php-fpm.tmpfiles $RPM_BUILD_ROOT%{_sysconfdir}/tmpfiles.d/php-fpm.conf
%endif
%endif

# Fix the link
(cd $RPM_BUILD_ROOT%{_bindir}; ln -sfn phar.phar phar)

# Generate files lists and stub .ini files for each subpackage
for mod in pgsql mysql mysqli odbc ldap snmp xmlrpc imap \
    mysqlnd mysqlnd_mysql mysqlnd_mysqli pdo_mysqlnd \
    mbstring gd dom xsl soap bcmath dba xmlreader xmlwriter \
    %{?_with_oci8:oci8} %{?_with_oci8:pdo_oci} %{?_with_ibase:interbase} %{?_with_ibase:pdo_firebird} sqlite \
    pdo pdo_mysql pdo_pgsql pdo_odbc pdo_sqlite json zip \
%if 0%{?fedora} >= 9  || 0%{?rhel} >= 6
    sqlite3 \
%endif
%if %{with_enchant}
    enchant \
%endif
    phar fileinfo intl \
    mcrypt tidy pdo_dblib mssql pspell curl wddx \
    posix sysvshm sysvsem sysvmsg recode; do
    cat > $RPM_BUILD_ROOT%{_sysconfdir}/php.d/${mod}.ini <<EOF
; Enable ${mod} extension module
extension=${mod}.so
EOF
    cat > files.${mod} <<EOF
%attr(755,root,root) %{_libdir}/%{phpname}/modules/${mod}.so
%config(noreplace) %attr(644,root,root) %{_sysconfdir}/php.d/${mod}.ini
EOF


if [ -f $RPM_BUILD_ROOT%{_libdir}/%{phpname}-zts/modules/${mod}.so ]
then
    cat > $RPM_BUILD_ROOT%{_sysconfdir}/php-zts.d/${mod}.ini <<EOF
; Enable ${mod} extension module
extension=${mod}.so
EOF
    cat >> files.${mod} <<EOF
%attr(755,root,root) %{_libdir}/%{phpname}-zts/modules/${mod}.so
%config(noreplace) %attr(644,root,root) %{_sysconfdir}/php-zts.d/${mod}.ini
EOF
else
    echo "** Extension ${mod} not available for ZTS build"
fi
done

# The dom, xsl and xml* modules are all packaged in php-xml
cat files.dom files.xsl files.xml{reader,writer} files.wddx > files.xml

# The mysql and mysqli modules are both packaged in php-mysql
cat files.mysqli >> files.mysql
# mysqlnd
cat files.mysqlnd_mysql \
    files.mysqlnd_mysqli \
    files.pdo_mysqlnd \
    >> files.mysqlnd


# Split out the PDO modules
cat files.pdo_dblib >> files.mssql
cat files.pdo_mysql >> files.mysql
cat files.pdo_pgsql >> files.pgsql
cat files.pdo_odbc >> files.odbc
%if %{with_oci8}
cat files.pdo_oci >> files.oci8
%endif
%if %{with_ibase}
cat files.pdo_firebird >> files.interbase
%endif

# sysv* and posix in packaged in php-process
cat files.sysv* files.posix > files.process

# Package sqlite and pdo_sqlite with pdo; isolating the sqlite dependency
# isn't useful at this time since rpm itself requires sqlite.
#cat files.sqlite >> files.pdo
cat files.pdo_sqlite >> files.pdo
%if 0%{?fedora} >= 9 || 0%{?rhel} >= 6
cat files.sqlite3 >> files.pdo
%endif

# Package json, zip, curl, phar and fileinfo in -common.
cat files.json files.curl files.phar files.fileinfo > files.common
%if %{with_zip}
cat files.zip >> files.common
%endif

# Install the macros file:
install -d $RPM_BUILD_ROOT%{_origsysconfdir}/rpm
sed -e "s/@PHP_APIVER@/%{apiver}%{isasuffix}/" \
    -e "s/@PHP_ZENDVER@/%{zendver}%{isasuffix}/" \
    -e "s/@PHP_PDOVER@/%{pdover}%{isasuffix}/" \
    -e "s/@PHPNAME@/%{phpname}/" \
    < %{SOURCE3} > macros.php
install -m 644 -c macros.php \
           $RPM_BUILD_ROOT%{_origsysconfdir}/rpm/macros.%{phpname}

# Remove unpackaged files
rm -rf $RPM_BUILD_ROOT%{_libdir}/%{phpname}/modules/*.a \
       $RPM_BUILD_ROOT%{_bindir}/{phptar} \
       $RPM_BUILD_ROOT%{peardir} \
       $RPM_BUILD_ROOT%{_libdir}/libphp5.la

# Remove irrelevant docs
rm -f README.{Zeus,QNX,CVS-RULES}

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
rm files.* macros.php

%pre common

%if %{with_fpm}
%post fpm
/sbin/chkconfig --add php-fpm

%preun fpm
if [ "$1" = 0 ] ; then
    /sbin/service php-fpm stop >/dev/null 2>&1
    /sbin/chkconfig --del php-fpm
fi
%endif

%post embedded -p /sbin/ldconfig
%postun embedded -p /sbin/ldconfig

%files
%defattr(-,root,root)
%if %{phpname} == php
%{_libdir}/httpd/modules/libphp5.so
%{_libdir}/httpd/modules/libphp5-zts.so
%else
%{_libdir}/httpd/modules/lib%{phpname}.so
%{_libdir}/httpd/modules/lib%{phpname}-zts.so
%endif
%attr(0770,root,apache) %dir %{_localstatedir}/lib/%{phpname}/session
%config(noreplace) %{_origsysconfdir}/httpd/conf.d/%{phpname}.conf
%{contentdir}/icons/%{phpname}.gif

%files common -f files.common
%defattr(-,root,root)
%doc CODING_STANDARDS CREDITS EXTENSIONS INSTALL LICENSE NEWS README*
%doc Zend/ZEND_* TSRM_LICENSE regex_COPYRIGHT UPGRADING
%doc php.ini-*
%config(noreplace) %{_sysconfdir}/php.ini
%dir %{_sysconfdir}/php.d
%dir %{_sysconfdir}/php-zts.d
%dir %{_libdir}/%{phpname}
%dir %{_libdir}/%{phpname}/modules
%dir %{_libdir}/%{phpname}-zts
%dir %{_libdir}/%{phpname}-zts/modules
%dir %{_localstatedir}/lib/php
%dir %{_datadir}/%{phpname}

%files cli
%defattr(-,root,root)
%{_bindir}/php
%{_bindir}/php-cgi
%{_bindir}/phar.phar
%{_bindir}/phar
# provides phpize here (not in -devel) for pecl command
%{_bindir}/phpize
%if %{phpname} == php
%{_mandir}/man1/php.1*
%{_mandir}/man1/phpize.1*
%else
%exclude %{_mandir}/man1/php.1*
%exclude %{_mandir}/man1/phpize.1*
%endif
%doc sapi/cgi/README* sapi/cli/README

%if %{with_fpm}
%files fpm
%defattr(-,root,root)
%doc php-fpm.conf.default
%config(noreplace) %{_sysconfdir}/php-fpm.conf
%config(noreplace) %{_origsysconfdir}/php-fpm.d/www.conf
%config(noreplace) %{_origsysconfdir}/logrotate.d/php-fpm
%if 0%{?fedora} >= 15
%config(noreplace) %{_sysconfdir}/tmpfiles.d/php-fpm.conf
%endif
%{_sbindir}/php-fpm
%{_originitdir}/php-fpm
%dir %{_origsysconfdir}/php-fpm.d
# log owned by apache for log
%attr(770,apache,apache) %dir %{_localstatedir}/log/php-fpm
%dir %{_localstatedir}/run/php-fpm
%{_mandir}/man8/php-fpm.8*
%{_datadir}/fpm/status.html
%endif

%files devel
%defattr(-,root,root)
%{_bindir}/php-config
%{_origbindir}/%{phpname}-zts/php-config
%{_origbindir}/%{phpname}-zts/phpize
%dir %{_origincludedir}/%{phpname}
%{_includedir}/php
%{_origincludedir}/%{phpname}-zts
%{_libdir}/%{phpname}/build
%{_libdir}/%{phpname}-zts/build
%if %{phpname} == php
%{_mandir}/man1/php-config.1*
%else
%exclude %{_mandir}/man1/php-config.1*
%endif
%config %{_origsysconfdir}/rpm/macros.%{phpname}

%files embedded
%defattr(-,root,root,-)
%{_libdir}/libphp5.so
%{_libdir}/libphp5-%{phpversion}.so

%files pgsql -f files.pgsql
%files mysql -f files.mysql
%files odbc -f files.odbc
%files imap -f files.imap
%files ldap -f files.ldap
%files snmp -f files.snmp
%files xml -f files.xml
%files xmlrpc -f files.xmlrpc
%files mbstring -f files.mbstring
%files gd -f files.gd
%defattr(-,root,root,-)
%doc gd_README
%files soap -f files.soap
%files bcmath -f files.bcmath
%files dba -f files.dba
%files pdo -f files.pdo
%files sqlite -f files.sqlite
%files mcrypt -f files.mcrypt
%files tidy -f files.tidy
%files mssql -f files.mssql
%files pspell -f files.pspell
%files intl -f files.intl
%files process -f files.process
%files recode -f files.recode
%if %{with_enchant}
%files enchant -f files.enchant
%endif
%files mysqlnd -f files.mysqlnd

%if %{with_oci8}
%files oci8 -f files.oci8
%endif

%if %{with_ibase}
%files interbase -f files.interbase
%endif

%changelog
* Thu Jul 11 2013 cs@linux-administrator.com
- update to release 5.3.27
* Wed Jun 12 2013 cs@linux-administrator.com
- update to release 5.3.26
* Thu May  9 2013 cs@linux-administrator.com
- update to release 5.3.25
* Mon Mar 18 2013 cs@linux-administrator.com
- update to release 5.3.23
* Sat Feb 23 2013 cs@linux-administrator.com
- update to release 5.3.22
* Sat Jan 19 2013 cs@linux-administrator.com
- update to release 5.3.21
* Sun Dec 23 2012 cs@linux-administrator.com
- update to version 5.3.20
* Sat Nov 24 2012 cs@linux-administrator.com
- update to version 5.3.19
* Sat Oct 20 2012 cs@linux-administrator.com
- update to version 5.3.18
* Mon Sep 17 2012 cs@linux-administrator.com
- update to version 5.3.17
* Sun Feb  5 2012 cs@linux-administrator.com
- initial version
